//========================================================//
#include <mega16.h>
#include <delay.h>
#include <stdio.h>
//#include <math.h>
#include <stdlib.h>
#include <alcd.h>
//========================================================//
#asm
.equ __lcd_port=0x12 ;PORTD 
#endasm 
//========================================================//
#define xtal 8000000
//#define buzzer PORTD.7
#define ADC_VREF_TYPE 0x40

//========================================================//
float A;
char buffer[32];
//========================================================//
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

//========================================================//
  void getI(){
  A=read_adc(0);
  A-=611;
  A*=0.0753521;
  A+=7.46; 
  }
//========================================================//
  void display(){
  getI(); 
  sprintf(buffer,"I:%f A",A);
  lcd_clear();
  lcd_puts(buffer);
  }
//========================================================//
  void main(void){
    lcd_init(16);
    PORTC=0x00;
    PORTD=0x00; 
    ACSR=0x80;
    SFIOR=0x00;
    ADMUX=ADC_VREF_TYPE & 0xff;
    ADCSRA=0x86;
    while (1){
     display();
    }
 }
//========================================================//